/* 
   $Id: sgbarwindow.c,v 1.3 2001/07/04 07:33:12 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgwm.

   sgwm is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgwm is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "sgwm.h"
#include <gdk/gdkx.h>
#include <X11/Xatom.h>
#include "sgbarwindow.h"
#include "sgwmwidget.h"
#include "atoms.h"

static void sgbarwindow_class_init(SGBarWindowClass *klass);
static void sgbarwindow_init(SGBarWindow *win);

GtkType sgbarwindow_get_type(void)
{
    static GtkType sgbarwindow_type = 0;

    if (sgbarwindow_type == 0) {
	GtkTypeInfo sgbarwindow_info = {
	    "SGBarWindow",
	    sizeof(SGBarWindow),
	    sizeof(SGBarWindowClass),
	    (GtkClassInitFunc)sgbarwindow_class_init,
	    (GtkObjectInitFunc)sgbarwindow_init,
	    NULL,
	    NULL,
	    NULL
	};
	sgbarwindow_type = gtk_type_unique(sgwindow_get_type(),
	    &sgbarwindow_info);
    }

    return sgbarwindow_type;
}

static GtkWidget *sgbarwindow_from_gdk_window(GdkWindow *win, guint32 xid,
 SGWMWidget *sgwm, gint type)
{
    GtkWidget *widget;

    gdk_error_trap_push();
    if (win == NULL) {
	widget = sgbarwindow_new(xid,sgwm,type);
    } else {
	gdk_window_get_user_data(win,(gpointer *)&widget);
	if (!IS_SGBARWINDOW(widget)) {
	    sgwmwidget_destroy_sgwin(sgwm,widget,xid);
	    widget = sgbarwindow_new(xid,sgwm,type);
	}
    }
    gdk_flush();
    if (gdk_error_trap_pop()) {
	return NULL;
    }
    return widget;
}

GtkWidget *sgbarwindow_lookup(guint32 xid, SGWMWidget *sgwm, gint type)
{
    GdkWindow *win;

    win = gdk_window_lookup(xid);
    return sgbarwindow_from_gdk_window(win,xid,sgwm,type);
}

static void sgbarwindow_class_init(SGBarWindowClass *klass)
{
}

static void sgbarwindow_init(SGBarWindow *win)
{
    win->x = 0;
    win->moved = FALSE;
}

GtkWidget *sgbarwindow_new(guint32 xid, SGWMWidget *sgwm, gint type)
{
    unsigned int data[1];
    GtkWidget *widget;
    SGBarWindow *sgbarwin;

    widget  = GTK_WIDGET(gtk_type_new(sgbarwindow_get_type()));
    sgbarwin = (SGBarWindow *)widget;
    sgbarwin->sgwin.type = type;
    if ((widget =  sgwindow_setup(&(sgbarwin->sgwin),xid,sgwm)) != NULL) {
	data[0] = (unsigned int)type;
	gdk_error_trap_push();
	XChangeProperty(GDK_DISPLAY(),xid,xa_sg_barwindow,
	  XA_CARDINAL,32,PropModeReplace,(unsigned char *)data,1);
	XAddToSaveSet(GDK_DISPLAY(),xid);
	gdk_flush();
	if (gdk_error_trap_pop()) {
	    ;
	}
    }
    return widget;
}
