/* 
   $Id: sgwmwidget.h,v 1.1.1.1 2001/03/14 08:31:48 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgwm.

   sgwm is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgwm is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef __SGWMWIDGET_H__
#define __SGWMWIDGET_H__

typedef struct _SGWMWidget SGWMWidget;
typedef struct _SGWMWidgetClass SGWMWidgetClass;

#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>

#define SGWMWIDGET(obj) (GTK_CHECK_CAST((obj),GTK_TYPE_SGWMWIDGET,SGWMWidget))
#define SGWMWIDGET_CLASS(klass) (GTK_CHECK_CLASS_CAST((klass),\
	GTK_TYPE_SGWMWIDGET,SGWMWidget))
#define IS_SGWMWIDGET(obj) (GTK_CHECK_TYPE((obj),GTK_TYPE_SGWMWIDGET))

#define GTK_TYPE_SGWMWIDGET (sgwmwidget_get_type())

#define SG_PANEL_WIDTH 20
#define SG_SUBAREA_SIZE(w) ((w*2)/3)

#define SG_N_WIN_PROTOCOLS 11

#define ICCCM_VERSION_MAJOR 2
#define ICCCM_VERSION_MINOR 0

#define SGWM_GRABBED_BINDING "SGWMGrabbedBinding"

struct _SGWMWidget {
    GtkWidget widget;
    GtkWidget *top;
    GdkWindow *leader;
    GList *client_list;
    GtkWidget *prompt;
    GtkWidget *desktop;
};

struct _SGWMWidgetClass {
    GtkWidgetClass parent_class;

    void (*swap_task) (SGWMWidget *sgwm, gint ws1, gint ws2);
    void (*enable_workspace) (SGWMWidget *sgwm, gint ws, gint enable);
    void (*activate_workspace)(SGWMWidget *sgwm, gint ws);
    void (*resize_workspace)(SGWMWidget *sgwm, gint ws, gint w, gint h);
    void (*call_desktop)(SGWMWidget *sgwm, gint ws);
    void (*map_task_to_workspace)(SGWMWidget *sgwm, gint win, gint ws);
    void (*map_task)(SGWMWidget *sgwm, gint win);
    void (*roll_up_task)(SGWMWidget *sgwm, gint ws);
    void (*roll_down_task)(SGWMWidget *sgwm, gint ws);
    void (*move_next_task)(SGWMWidget *sgwm, gint ws);
    void (*move_prev_task)(SGWMWidget *sgwm, gint ws);
};

extern GtkType sgwmwidget_get_type(void);
extern GtkWidget *sgwmwidget_new(void);
extern GdkFilterReturn sgwmwidget_filter(GdkXEvent *xevent,
  GdkEvent *event, gpointer data);
extern void sgwmwidget_do_activate_workspace(SGWMWidget *sgwm,
  gint no, gboolean warp, gboolean focus);
extern void sgwmwidget_exit(int status);
extern void sgwmwidget_start(SGWMWidget *sgwm);
extern void sgwmwidget_destroy_sgwin(SGWMWidget *sgwm, GtkWidget *widget,
  guint xid);

extern gint middleButtonKeycode;
extern gint rightButtonKeycode;

#endif
